t / test-lib.shon commit Merge branch 'kd/t0028-octal-del-is-377-not-777' (29825a8)
   1# Test framework for git.  See t/README for usage.
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# This program is free software: you can redistribute it and/or modify
   6# it under the terms of the GNU General Public License as published by
   7# the Free Software Foundation, either version 2 of the License, or
   8# (at your option) any later version.
   9#
  10# This program is distributed in the hope that it will be useful,
  11# but WITHOUT ANY WARRANTY; without even the implied warranty of
  12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  13# GNU General Public License for more details.
  14#
  15# You should have received a copy of the GNU General Public License
  16# along with this program.  If not, see http://www.gnu.org/licenses/ .
  17
  18# Test the binaries we have just built.  The tests are kept in
  19# t/ subdirectory and are run in 'trash directory' subdirectory.
  20if test -z "$TEST_DIRECTORY"
  21then
  22        # We allow tests to override this, in case they want to run tests
  23        # outside of t/, e.g. for running tests on the test library
  24        # itself.
  25        TEST_DIRECTORY=$(pwd)
  26else
  27        # ensure that TEST_DIRECTORY is an absolute path so that it
  28        # is valid even if the current working directory is changed
  29        TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
  30fi
  31if test -z "$TEST_OUTPUT_DIRECTORY"
  32then
  33        # Similarly, override this to store the test-results subdir
  34        # elsewhere
  35        TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
  36fi
  37GIT_BUILD_DIR="$TEST_DIRECTORY"/..
  38
  39# If we were built with ASAN, it may complain about leaks
  40# of program-lifetime variables. Disable it by default to lower
  41# the noise level. This needs to happen at the start of the script,
  42# before we even do our "did we build git yet" check (since we don't
  43# want that one to complain to stderr).
  44: ${ASAN_OPTIONS=detect_leaks=0:abort_on_error=1}
  45export ASAN_OPTIONS
  46
  47# If LSAN is in effect we _do_ want leak checking, but we still
  48# want to abort so that we notice the problems.
  49: ${LSAN_OPTIONS=abort_on_error=1}
  50export LSAN_OPTIONS
  51
  52if test ! -f "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
  53then
  54        echo >&2 'error: GIT-BUILD-OPTIONS missing (has Git been built?).'
  55        exit 1
  56fi
  57. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
  58export PERL_PATH SHELL_PATH
  59
  60################################################################
  61# It appears that people try to run tests without building...
  62"${GIT_TEST_INSTALLED:-$GIT_BUILD_DIR}/git$X" >/dev/null
  63if test $? != 1
  64then
  65        if test -n "$GIT_TEST_INSTALLED"
  66        then
  67                echo >&2 "error: there is no working Git at '$GIT_TEST_INSTALLED'"
  68        else
  69                echo >&2 'error: you do not seem to have built git yet.'
  70        fi
  71        exit 1
  72fi
  73
  74# Parse options while taking care to leave $@ intact, so we will still
  75# have all the original command line options when executing the test
  76# script again for '--tee' and '--verbose-log' below.
  77store_arg_to=
  78prev_opt=
  79for opt
  80do
  81        if test -n "$store_arg_to"
  82        then
  83                eval $store_arg_to=\$opt
  84                store_arg_to=
  85                prev_opt=
  86                continue
  87        fi
  88
  89        case "$opt" in
  90        -d|--d|--de|--deb|--debu|--debug)
  91                debug=t ;;
  92        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
  93                immediate=t ;;
  94        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
  95                GIT_TEST_LONG=t; export GIT_TEST_LONG ;;
  96        -r)
  97                store_arg_to=run_list
  98                ;;
  99        --run=*)
 100                run_list=${opt#--*=} ;;
 101        -h|--h|--he|--hel|--help)
 102                help=t ;;
 103        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 104                verbose=t ;;
 105        --verbose-only=*)
 106                verbose_only=${opt#--*=}
 107                ;;
 108        -q|--q|--qu|--qui|--quie|--quiet)
 109                # Ignore --quiet under a TAP::Harness. Saying how many tests
 110                # passed without the ok/not ok details is always an error.
 111                test -z "$HARNESS_ACTIVE" && quiet=t ;;
 112        --with-dashes)
 113                with_dashes=t ;;
 114        --no-bin-wrappers)
 115                no_bin_wrappers=t ;;
 116        --no-color)
 117                color= ;;
 118        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 119                valgrind=memcheck
 120                tee=t
 121                ;;
 122        --valgrind=*)
 123                valgrind=${opt#--*=}
 124                tee=t
 125                ;;
 126        --valgrind-only=*)
 127                valgrind_only=${opt#--*=}
 128                tee=t
 129                ;;
 130        --tee)
 131                tee=t ;;
 132        --root=*)
 133                root=${opt#--*=} ;;
 134        --chain-lint)
 135                GIT_TEST_CHAIN_LINT=1 ;;
 136        --no-chain-lint)
 137                GIT_TEST_CHAIN_LINT=0 ;;
 138        -x)
 139                trace=t ;;
 140        -V|--verbose-log)
 141                verbose_log=t
 142                tee=t
 143                ;;
 144        --write-junit-xml)
 145                write_junit_xml=t
 146                ;;
 147        --stress)
 148                stress=t ;;
 149        --stress=*)
 150                stress=${opt#--*=}
 151                case "$stress" in
 152                *[^0-9]*|0*|"")
 153                        echo "error: --stress=<N> requires the number of jobs to run" >&2
 154                        exit 1
 155                        ;;
 156                *)      # Good.
 157                        ;;
 158                esac
 159                ;;
 160        *)
 161                echo "error: unknown test option '$opt'" >&2; exit 1 ;;
 162        esac
 163
 164        prev_opt=$opt
 165done
 166if test -n "$store_arg_to"
 167then
 168        echo "error: $prev_opt requires an argument" >&2
 169        exit 1
 170fi
 171
 172if test -n "$valgrind_only"
 173then
 174        test -z "$valgrind" && valgrind=memcheck
 175        test -z "$verbose" && verbose_only="$valgrind_only"
 176elif test -n "$valgrind"
 177then
 178        test -z "$verbose_log" && verbose=t
 179fi
 180
 181if test -n "$stress"
 182then
 183        verbose=t
 184        trace=t
 185        immediate=t
 186fi
 187
 188TEST_STRESS_JOB_SFX="${GIT_TEST_STRESS_JOB_NR:+.stress-$GIT_TEST_STRESS_JOB_NR}"
 189TEST_NAME="$(basename "$0" .sh)"
 190TEST_RESULTS_DIR="$TEST_OUTPUT_DIRECTORY/test-results"
 191TEST_RESULTS_BASE="$TEST_RESULTS_DIR/$TEST_NAME$TEST_STRESS_JOB_SFX"
 192TRASH_DIRECTORY="trash directory.$TEST_NAME$TEST_STRESS_JOB_SFX"
 193test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
 194case "$TRASH_DIRECTORY" in
 195/*) ;; # absolute path is good
 196 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
 197esac
 198
 199# If --stress was passed, run this test repeatedly in several parallel loops.
 200if test "$GIT_TEST_STRESS_STARTED" = "done"
 201then
 202        : # Don't stress test again.
 203elif test -n "$stress"
 204then
 205        if test "$stress" != t
 206        then
 207                job_count=$stress
 208        elif test -n "$GIT_TEST_STRESS_LOAD"
 209        then
 210                job_count="$GIT_TEST_STRESS_LOAD"
 211        elif job_count=$(getconf _NPROCESSORS_ONLN 2>/dev/null) &&
 212             test -n "$job_count"
 213        then
 214                job_count=$((2 * $job_count))
 215        else
 216                job_count=8
 217        fi
 218
 219        mkdir -p "$TEST_RESULTS_DIR"
 220        stressfail="$TEST_RESULTS_BASE.stress-failed"
 221        rm -f "$stressfail"
 222
 223        stress_exit=0
 224        trap '
 225                kill $job_pids 2>/dev/null
 226                wait
 227                stress_exit=1
 228        ' TERM INT HUP
 229
 230        job_pids=
 231        job_nr=0
 232        while test $job_nr -lt "$job_count"
 233        do
 234                (
 235                        GIT_TEST_STRESS_STARTED=done
 236                        GIT_TEST_STRESS_JOB_NR=$job_nr
 237                        export GIT_TEST_STRESS_STARTED GIT_TEST_STRESS_JOB_NR
 238
 239                        trap '
 240                                kill $test_pid 2>/dev/null
 241                                wait
 242                                exit 1
 243                        ' TERM INT
 244
 245                        cnt=0
 246                        while ! test -e "$stressfail"
 247                        do
 248                                $TEST_SHELL_PATH "$0" "$@" >"$TEST_RESULTS_BASE.stress-$job_nr.out" 2>&1 &
 249                                test_pid=$!
 250
 251                                if wait $test_pid
 252                                then
 253                                        printf "OK   %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
 254                                else
 255                                        echo $GIT_TEST_STRESS_JOB_NR >>"$stressfail"
 256                                        printf "FAIL %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
 257                                fi
 258                                cnt=$(($cnt + 1))
 259                        done
 260                ) &
 261                job_pids="$job_pids $!"
 262                job_nr=$(($job_nr + 1))
 263        done
 264
 265        wait
 266
 267        if test -f "$stressfail"
 268        then
 269                echo "Log(s) of failed test run(s):"
 270                for failed_job_nr in $(sort -n "$stressfail")
 271                do
 272                        echo "Contents of '$TEST_RESULTS_BASE.stress-$failed_job_nr.out':"
 273                        cat "$TEST_RESULTS_BASE.stress-$failed_job_nr.out"
 274                done
 275                rm -rf "$TRASH_DIRECTORY.stress-failed"
 276                # Move the last one.
 277                mv "$TRASH_DIRECTORY.stress-$failed_job_nr" "$TRASH_DIRECTORY.stress-failed"
 278        fi
 279
 280        exit $stress_exit
 281fi
 282
 283# if --tee was passed, write the output not only to the terminal, but
 284# additionally to the file test-results/$BASENAME.out, too.
 285if test "$GIT_TEST_TEE_STARTED" = "done"
 286then
 287        : # do not redirect again
 288elif test -n "$tee"
 289then
 290        mkdir -p "$TEST_RESULTS_DIR"
 291
 292        # Make this filename available to the sub-process in case it is using
 293        # --verbose-log.
 294        GIT_TEST_TEE_OUTPUT_FILE=$TEST_RESULTS_BASE.out
 295        export GIT_TEST_TEE_OUTPUT_FILE
 296
 297        # Truncate before calling "tee -a" to get rid of the results
 298        # from any previous runs.
 299        >"$GIT_TEST_TEE_OUTPUT_FILE"
 300
 301        (GIT_TEST_TEE_STARTED=done ${TEST_SHELL_PATH} "$0" "$@" 2>&1;
 302         echo $? >"$TEST_RESULTS_BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
 303        test "$(cat "$TEST_RESULTS_BASE.exit")" = 0
 304        exit
 305fi
 306
 307if test -n "$trace" && test -n "$test_untraceable"
 308then
 309        # '-x' tracing requested, but this test script can't be reliably
 310        # traced, unless it is run with a Bash version supporting
 311        # BASH_XTRACEFD (introduced in Bash v4.1).
 312        #
 313        # Perform this version check _after_ the test script was
 314        # potentially re-executed with $TEST_SHELL_PATH for '--tee' or
 315        # '--verbose-log', so the right shell is checked and the
 316        # warning is issued only once.
 317        if test -n "$BASH_VERSION" && eval '
 318             test ${BASH_VERSINFO[0]} -gt 4 || {
 319               test ${BASH_VERSINFO[0]} -eq 4 &&
 320               test ${BASH_VERSINFO[1]} -ge 1
 321             }
 322           '
 323        then
 324                : Executed by a Bash version supporting BASH_XTRACEFD.  Good.
 325        else
 326                echo >&2 "warning: ignoring -x; '$0' is untraceable without BASH_XTRACEFD"
 327                trace=
 328        fi
 329fi
 330if test -n "$trace" && test -z "$verbose_log"
 331then
 332        verbose=t
 333fi
 334
 335# For repeatability, reset the environment to known value.
 336# TERM is sanitized below, after saving color control sequences.
 337LANG=C
 338LC_ALL=C
 339PAGER=cat
 340TZ=UTC
 341export LANG LC_ALL PAGER TZ
 342EDITOR=:
 343
 344# GIT_TEST_GETTEXT_POISON should not influence git commands executed
 345# during initialization of test-lib and the test repo. Back it up,
 346# unset and then restore after initialization is finished.
 347if test -n "$GIT_TEST_GETTEXT_POISON"
 348then
 349        GIT_TEST_GETTEXT_POISON_ORIG=$GIT_TEST_GETTEXT_POISON
 350        unset GIT_TEST_GETTEXT_POISON
 351fi
 352
 353# A call to "unset" with no arguments causes at least Solaris 10
 354# /usr/xpg4/bin/sh and /bin/ksh to bail out.  So keep the unsets
 355# deriving from the command substitution clustered with the other
 356# ones.
 357unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
 358        my @env = keys %ENV;
 359        my $ok = join("|", qw(
 360                TRACE
 361                DEBUG
 362                TEST
 363                .*_TEST
 364                PROVE
 365                VALGRIND
 366                UNZIP
 367                PERF_
 368                CURL_VERBOSE
 369                TRACE_CURL
 370        ));
 371        my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
 372        print join("\n", @vars);
 373')
 374unset XDG_CACHE_HOME
 375unset XDG_CONFIG_HOME
 376unset GITPERLLIB
 377GIT_AUTHOR_EMAIL=author@example.com
 378GIT_AUTHOR_NAME='A U Thor'
 379GIT_COMMITTER_EMAIL=committer@example.com
 380GIT_COMMITTER_NAME='C O Mitter'
 381GIT_MERGE_VERBOSITY=5
 382GIT_MERGE_AUTOEDIT=no
 383export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
 384export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
 385export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
 386export EDITOR
 387
 388# Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
 389GIT_TRACE_BARE=1
 390export GIT_TRACE_BARE
 391
 392check_var_migration () {
 393        # the warnings and hints given from this helper depends
 394        # on end-user settings, which will disrupt the self-test
 395        # done on the test framework itself.
 396        case "$GIT_TEST_FRAMEWORK_SELFTEST" in
 397        t)      return ;;
 398        esac
 399
 400        old_name=$1 new_name=$2
 401        eval "old_isset=\${${old_name}:+isset}"
 402        eval "new_isset=\${${new_name}:+isset}"
 403
 404        case "$old_isset,$new_isset" in
 405        isset,)
 406                echo >&2 "warning: $old_name is now $new_name"
 407                echo >&2 "hint: set $new_name too during the transition period"
 408                eval "$new_name=\$$old_name"
 409                ;;
 410        isset,isset)
 411                # do this later
 412                # echo >&2 "warning: $old_name is now $new_name"
 413                # echo >&2 "hint: remove $old_name"
 414                ;;
 415        esac
 416}
 417
 418check_var_migration GIT_FSMONITOR_TEST GIT_TEST_FSMONITOR
 419check_var_migration TEST_GIT_INDEX_VERSION GIT_TEST_INDEX_VERSION
 420check_var_migration GIT_FORCE_PRELOAD_TEST GIT_TEST_PRELOAD_INDEX
 421
 422# Use specific version of the index file format
 423if test -n "${GIT_TEST_INDEX_VERSION:+isset}"
 424then
 425        GIT_INDEX_VERSION="$GIT_TEST_INDEX_VERSION"
 426        export GIT_INDEX_VERSION
 427fi
 428
 429# Add libc MALLOC and MALLOC_PERTURB test
 430# only if we are not executing the test with valgrind
 431if test -n "$valgrind" ||
 432   test -n "$TEST_NO_MALLOC_CHECK"
 433then
 434        setup_malloc_check () {
 435                : nothing
 436        }
 437        teardown_malloc_check () {
 438                : nothing
 439        }
 440else
 441        setup_malloc_check () {
 442                MALLOC_CHECK_=3 MALLOC_PERTURB_=165
 443                export MALLOC_CHECK_ MALLOC_PERTURB_
 444        }
 445        teardown_malloc_check () {
 446                unset MALLOC_CHECK_ MALLOC_PERTURB_
 447        }
 448fi
 449
 450# Protect ourselves from common misconfiguration to export
 451# CDPATH into the environment
 452unset CDPATH
 453
 454unset GREP_OPTIONS
 455unset UNZIP
 456
 457case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
 4581|2|true)
 459        GIT_TRACE=4
 460        ;;
 461esac
 462
 463# Convenience
 464#
 465# A regexp to match 5, 35 and 40 hexdigits
 466_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
 467_x35="$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
 468_x40="$_x35$_x05"
 469
 470# Zero SHA-1
 471_z40=0000000000000000000000000000000000000000
 472
 473OID_REGEX="$_x40"
 474ZERO_OID=$_z40
 475EMPTY_TREE=4b825dc642cb6eb9a060e54bf8d69288fbee4904
 476EMPTY_BLOB=e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
 477
 478# Line feed
 479LF='
 480'
 481
 482# UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
 483# when case-folding filenames
 484u200c=$(printf '\342\200\214')
 485
 486export _x05 _x35 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB ZERO_OID OID_REGEX
 487
 488# Each test should start with something like this, after copyright notices:
 489#
 490# test_description='Description of this test...
 491# This test checks if command xyzzy does the right thing...
 492# '
 493# . ./test-lib.sh
 494test "x$TERM" != "xdumb" && (
 495                test -t 1 &&
 496                tput bold >/dev/null 2>&1 &&
 497                tput setaf 1 >/dev/null 2>&1 &&
 498                tput sgr0 >/dev/null 2>&1
 499        ) &&
 500        color=t
 501
 502if test -n "$color"
 503then
 504        # Save the color control sequences now rather than run tput
 505        # each time say_color() is called.  This is done for two
 506        # reasons:
 507        #   * TERM will be changed to dumb
 508        #   * HOME will be changed to a temporary directory and tput
 509        #     might need to read ~/.terminfo from the original HOME
 510        #     directory to get the control sequences
 511        # Note:  This approach assumes the control sequences don't end
 512        # in a newline for any terminal of interest (command
 513        # substitutions strip trailing newlines).  Given that most
 514        # (all?) terminals in common use are related to ECMA-48, this
 515        # shouldn't be a problem.
 516        say_color_error=$(tput bold; tput setaf 1) # bold red
 517        say_color_skip=$(tput setaf 4) # blue
 518        say_color_warn=$(tput setaf 3) # brown/yellow
 519        say_color_pass=$(tput setaf 2) # green
 520        say_color_info=$(tput setaf 6) # cyan
 521        say_color_reset=$(tput sgr0)
 522        say_color_="" # no formatting for normal text
 523        say_color () {
 524                test -z "$1" && test -n "$quiet" && return
 525                eval "say_color_color=\$say_color_$1"
 526                shift
 527                printf "%s\\n" "$say_color_color$*$say_color_reset"
 528        }
 529else
 530        say_color() {
 531                test -z "$1" && test -n "$quiet" && return
 532                shift
 533                printf "%s\n" "$*"
 534        }
 535fi
 536
 537TERM=dumb
 538export TERM
 539
 540error () {
 541        say_color error "error: $*"
 542        GIT_EXIT_OK=t
 543        exit 1
 544}
 545
 546BUG () {
 547        error >&7 "bug in the test script: $*"
 548}
 549
 550say () {
 551        say_color info "$*"
 552}
 553
 554if test -n "$HARNESS_ACTIVE"
 555then
 556        if test "$verbose" = t || test -n "$verbose_only"
 557        then
 558                printf 'Bail out! %s\n' \
 559                 'verbose mode forbidden under TAP harness; try --verbose-log'
 560                exit 1
 561        fi
 562fi
 563
 564test "${test_description}" != "" ||
 565error "Test script did not set test_description."
 566
 567if test "$help" = "t"
 568then
 569        printf '%s\n' "$test_description"
 570        exit 0
 571fi
 572
 573exec 5>&1
 574exec 6<&0
 575exec 7>&2
 576if test "$verbose_log" = "t"
 577then
 578        exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
 579elif test "$verbose" = "t"
 580then
 581        exec 4>&2 3>&1
 582else
 583        exec 4>/dev/null 3>/dev/null
 584fi
 585
 586# Send any "-x" output directly to stderr to avoid polluting tests
 587# which capture stderr. We can do this unconditionally since it
 588# has no effect if tracing isn't turned on.
 589#
 590# Note that this sets up the trace fd as soon as we assign the variable, so it
 591# must come after the creation of descriptor 4 above. Likewise, we must never
 592# unset this, as it has the side effect of closing descriptor 4, which we
 593# use to show verbose tests to the user.
 594#
 595# Note also that we don't need or want to export it. The tracing is local to
 596# this shell, and we would not want to influence any shells we exec.
 597BASH_XTRACEFD=4
 598
 599test_failure=0
 600test_count=0
 601test_fixed=0
 602test_broken=0
 603test_success=0
 604
 605test_external_has_tap=0
 606
 607die () {
 608        code=$?
 609        if test -n "$GIT_EXIT_OK"
 610        then
 611                exit $code
 612        else
 613                echo >&5 "FATAL: Unexpected exit with code $code"
 614                exit 1
 615        fi
 616}
 617
 618GIT_EXIT_OK=
 619trap 'die' EXIT
 620trap 'exit $?' INT TERM HUP
 621
 622# The user-facing functions are loaded from a separate file so that
 623# test_perf subshells can have them too
 624. "$TEST_DIRECTORY/test-lib-functions.sh"
 625
 626# You are not expected to call test_ok_ and test_failure_ directly, use
 627# the test_expect_* functions instead.
 628
 629test_ok_ () {
 630        if test -n "$write_junit_xml"
 631        then
 632                write_junit_xml_testcase "$*"
 633        fi
 634        test_success=$(($test_success + 1))
 635        say_color "" "ok $test_count - $@"
 636}
 637
 638test_failure_ () {
 639        if test -n "$write_junit_xml"
 640        then
 641                junit_insert="<failure message=\"not ok $test_count -"
 642                junit_insert="$junit_insert $(xml_attr_encode "$1")\">"
 643                junit_insert="$junit_insert $(xml_attr_encode \
 644                        "$(if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
 645                           then
 646                                test-tool path-utils skip-n-bytes \
 647                                        "$GIT_TEST_TEE_OUTPUT_FILE" $GIT_TEST_TEE_OFFSET
 648                           else
 649                                printf '%s\n' "$@" | sed 1d
 650                           fi)")"
 651                junit_insert="$junit_insert</failure>"
 652                if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
 653                then
 654                        junit_insert="$junit_insert<system-err>$(xml_attr_encode \
 655                                "$(cat "$GIT_TEST_TEE_OUTPUT_FILE")")</system-err>"
 656                fi
 657                write_junit_xml_testcase "$1" "      $junit_insert"
 658        fi
 659        test_failure=$(($test_failure + 1))
 660        say_color error "not ok $test_count - $1"
 661        shift
 662        printf '%s\n' "$*" | sed -e 's/^/#      /'
 663        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 664}
 665
 666test_known_broken_ok_ () {
 667        if test -n "$write_junit_xml"
 668        then
 669                write_junit_xml_testcase "$* (breakage fixed)"
 670        fi
 671        test_fixed=$(($test_fixed+1))
 672        say_color error "ok $test_count - $@ # TODO known breakage vanished"
 673}
 674
 675test_known_broken_failure_ () {
 676        if test -n "$write_junit_xml"
 677        then
 678                write_junit_xml_testcase "$* (known breakage)"
 679        fi
 680        test_broken=$(($test_broken+1))
 681        say_color warn "not ok $test_count - $@ # TODO known breakage"
 682}
 683
 684test_debug () {
 685        test "$debug" = "" || eval "$1"
 686}
 687
 688match_pattern_list () {
 689        arg="$1"
 690        shift
 691        test -z "$*" && return 1
 692        for pattern_
 693        do
 694                case "$arg" in
 695                $pattern_)
 696                        return 0
 697                esac
 698        done
 699        return 1
 700}
 701
 702match_test_selector_list () {
 703        title="$1"
 704        shift
 705        arg="$1"
 706        shift
 707        test -z "$1" && return 0
 708
 709        # Both commas and whitespace are accepted as separators.
 710        OLDIFS=$IFS
 711        IFS='   ,'
 712        set -- $1
 713        IFS=$OLDIFS
 714
 715        # If the first selector is negative we include by default.
 716        include=
 717        case "$1" in
 718                !*) include=t ;;
 719        esac
 720
 721        for selector
 722        do
 723                orig_selector=$selector
 724
 725                positive=t
 726                case "$selector" in
 727                        !*)
 728                                positive=
 729                                selector=${selector##?}
 730                                ;;
 731                esac
 732
 733                test -z "$selector" && continue
 734
 735                case "$selector" in
 736                        *-*)
 737                                if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
 738                                then
 739                                        echo "error: $title: invalid non-numeric in range" \
 740                                                "start: '$orig_selector'" >&2
 741                                        exit 1
 742                                fi
 743                                if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
 744                                then
 745                                        echo "error: $title: invalid non-numeric in range" \
 746                                                "end: '$orig_selector'" >&2
 747                                        exit 1
 748                                fi
 749                                ;;
 750                        *)
 751                                if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
 752                                then
 753                                        echo "error: $title: invalid non-numeric in test" \
 754                                                "selector: '$orig_selector'" >&2
 755                                        exit 1
 756                                fi
 757                esac
 758
 759                # Short cut for "obvious" cases
 760                test -z "$include" && test -z "$positive" && continue
 761                test -n "$include" && test -n "$positive" && continue
 762
 763                case "$selector" in
 764                        -*)
 765                                if test $arg -le ${selector#-}
 766                                then
 767                                        include=$positive
 768                                fi
 769                                ;;
 770                        *-)
 771                                if test $arg -ge ${selector%-}
 772                                then
 773                                        include=$positive
 774                                fi
 775                                ;;
 776                        *-*)
 777                                if test ${selector%%-*} -le $arg \
 778                                        && test $arg -le ${selector#*-}
 779                                then
 780                                        include=$positive
 781                                fi
 782                                ;;
 783                        *)
 784                                if test $arg -eq $selector
 785                                then
 786                                        include=$positive
 787                                fi
 788                                ;;
 789                esac
 790        done
 791
 792        test -n "$include"
 793}
 794
 795maybe_teardown_verbose () {
 796        test -z "$verbose_only" && return
 797        exec 4>/dev/null 3>/dev/null
 798        verbose=
 799}
 800
 801last_verbose=t
 802maybe_setup_verbose () {
 803        test -z "$verbose_only" && return
 804        if match_pattern_list $test_count $verbose_only
 805        then
 806                exec 4>&2 3>&1
 807                # Emit a delimiting blank line when going from
 808                # non-verbose to verbose.  Within verbose mode the
 809                # delimiter is printed by test_expect_*.  The choice
 810                # of the initial $last_verbose is such that before
 811                # test 1, we do not print it.
 812                test -z "$last_verbose" && echo >&3 ""
 813                verbose=t
 814        else
 815                exec 4>/dev/null 3>/dev/null
 816                verbose=
 817        fi
 818        last_verbose=$verbose
 819}
 820
 821maybe_teardown_valgrind () {
 822        test -z "$GIT_VALGRIND" && return
 823        GIT_VALGRIND_ENABLED=
 824}
 825
 826maybe_setup_valgrind () {
 827        test -z "$GIT_VALGRIND" && return
 828        if test -z "$valgrind_only"
 829        then
 830                GIT_VALGRIND_ENABLED=t
 831                return
 832        fi
 833        GIT_VALGRIND_ENABLED=
 834        if match_pattern_list $test_count $valgrind_only
 835        then
 836                GIT_VALGRIND_ENABLED=t
 837        fi
 838}
 839
 840want_trace () {
 841        test "$trace" = t && {
 842                test "$verbose" = t || test "$verbose_log" = t
 843        }
 844}
 845
 846# This is a separate function because some tests use
 847# "return" to end a test_expect_success block early
 848# (and we want to make sure we run any cleanup like
 849# "set +x").
 850test_eval_inner_ () {
 851        # Do not add anything extra (including LF) after '$*'
 852        eval "
 853                want_trace && set -x
 854                $*"
 855}
 856
 857test_eval_ () {
 858        # If "-x" tracing is in effect, then we want to avoid polluting stderr
 859        # with non-test commands. But once in "set -x" mode, we cannot prevent
 860        # the shell from printing the "set +x" to turn it off (nor the saving
 861        # of $? before that). But we can make sure that the output goes to
 862        # /dev/null.
 863        #
 864        # There are a few subtleties here:
 865        #
 866        #   - we have to redirect descriptor 4 in addition to 2, to cover
 867        #     BASH_XTRACEFD
 868        #
 869        #   - the actual eval has to come before the redirection block (since
 870        #     it needs to see descriptor 4 to set up its stderr)
 871        #
 872        #   - likewise, any error message we print must be outside the block to
 873        #     access descriptor 4
 874        #
 875        #   - checking $? has to come immediately after the eval, but it must
 876        #     be _inside_ the block to avoid polluting the "set -x" output
 877        #
 878
 879        test_eval_inner_ "$@" </dev/null >&3 2>&4
 880        {
 881                test_eval_ret_=$?
 882                if want_trace
 883                then
 884                        set +x
 885                fi
 886        } 2>/dev/null 4>&2
 887
 888        if test "$test_eval_ret_" != 0 && want_trace
 889        then
 890                say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
 891        fi
 892        return $test_eval_ret_
 893}
 894
 895test_run_ () {
 896        test_cleanup=:
 897        expecting_failure=$2
 898
 899        if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
 900                # turn off tracing for this test-eval, as it simply creates
 901                # confusing noise in the "-x" output
 902                trace_tmp=$trace
 903                trace=
 904                # 117 is magic because it is unlikely to match the exit
 905                # code of other programs
 906                if $(printf '%s\n' "$1" | sed -f "$GIT_BUILD_DIR/t/chainlint.sed" | grep -q '?![A-Z][A-Z]*?!') ||
 907                        test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)"
 908                then
 909                        BUG "broken &&-chain or run-away HERE-DOC: $1"
 910                fi
 911                trace=$trace_tmp
 912        fi
 913
 914        setup_malloc_check
 915        test_eval_ "$1"
 916        eval_ret=$?
 917        teardown_malloc_check
 918
 919        if test -z "$immediate" || test $eval_ret = 0 ||
 920           test -n "$expecting_failure" && test "$test_cleanup" != ":"
 921        then
 922                setup_malloc_check
 923                test_eval_ "$test_cleanup"
 924                teardown_malloc_check
 925        fi
 926        if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
 927        then
 928                echo ""
 929        fi
 930        return "$eval_ret"
 931}
 932
 933test_start_ () {
 934        test_count=$(($test_count+1))
 935        maybe_setup_verbose
 936        maybe_setup_valgrind
 937        if test -n "$write_junit_xml"
 938        then
 939                junit_start=$(test-tool date getnanos)
 940        fi
 941}
 942
 943test_finish_ () {
 944        echo >&3 ""
 945        maybe_teardown_valgrind
 946        maybe_teardown_verbose
 947        if test -n "$GIT_TEST_TEE_OFFSET"
 948        then
 949                GIT_TEST_TEE_OFFSET=$(test-tool path-utils file-size \
 950                        "$GIT_TEST_TEE_OUTPUT_FILE")
 951        fi
 952}
 953
 954test_skip () {
 955        to_skip=
 956        skipped_reason=
 957        if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
 958        then
 959                to_skip=t
 960                skipped_reason="GIT_SKIP_TESTS"
 961        fi
 962        if test -z "$to_skip" && test -n "$test_prereq" &&
 963           ! test_have_prereq "$test_prereq"
 964        then
 965                to_skip=t
 966
 967                of_prereq=
 968                if test "$missing_prereq" != "$test_prereq"
 969                then
 970                        of_prereq=" of $test_prereq"
 971                fi
 972                skipped_reason="missing $missing_prereq${of_prereq}"
 973        fi
 974        if test -z "$to_skip" && test -n "$run_list" &&
 975                ! match_test_selector_list '--run' $test_count "$run_list"
 976        then
 977                to_skip=t
 978                skipped_reason="--run"
 979        fi
 980
 981        case "$to_skip" in
 982        t)
 983                if test -n "$write_junit_xml"
 984                then
 985                        message="$(xml_attr_encode "$skipped_reason")"
 986                        write_junit_xml_testcase "$1" \
 987                                "      <skipped message=\"$message\" />"
 988                fi
 989
 990                say_color skip >&3 "skipping test: $@"
 991                say_color skip "ok $test_count # skip $1 ($skipped_reason)"
 992                : true
 993                ;;
 994        *)
 995                false
 996                ;;
 997        esac
 998}
 999
1000# stub; perf-lib overrides it
1001test_at_end_hook_ () {
1002        :
1003}
1004
1005write_junit_xml () {
1006        case "$1" in
1007        --truncate)
1008                >"$junit_xml_path"
1009                junit_have_testcase=
1010                shift
1011                ;;
1012        esac
1013        printf '%s\n' "$@" >>"$junit_xml_path"
1014}
1015
1016xml_attr_encode () {
1017        printf '%s\n' "$@" | test-tool xml-encode
1018}
1019
1020write_junit_xml_testcase () {
1021        junit_attrs="name=\"$(xml_attr_encode "$this_test.$test_count $1")\""
1022        shift
1023        junit_attrs="$junit_attrs classname=\"$this_test\""
1024        junit_attrs="$junit_attrs time=\"$(test-tool \
1025                date getnanos $junit_start)\""
1026        write_junit_xml "$(printf '%s\n' \
1027                "    <testcase $junit_attrs>" "$@" "    </testcase>")"
1028        junit_have_testcase=t
1029}
1030
1031test_done () {
1032        GIT_EXIT_OK=t
1033
1034        if test -n "$write_junit_xml" && test -n "$junit_xml_path"
1035        then
1036                test -n "$junit_have_testcase" || {
1037                        junit_start=$(test-tool date getnanos)
1038                        write_junit_xml_testcase "all tests skipped"
1039                }
1040
1041                # adjust the overall time
1042                junit_time=$(test-tool date getnanos $junit_suite_start)
1043                sed "s/<testsuite [^>]*/& time=\"$junit_time\"/" \
1044                        <"$junit_xml_path" >"$junit_xml_path.new"
1045                mv "$junit_xml_path.new" "$junit_xml_path"
1046
1047                write_junit_xml "  </testsuite>" "</testsuites>"
1048        fi
1049
1050        if test -z "$HARNESS_ACTIVE"
1051        then
1052                mkdir -p "$TEST_RESULTS_DIR"
1053
1054                cat >"$TEST_RESULTS_BASE.counts" <<-EOF
1055                total $test_count
1056                success $test_success
1057                fixed $test_fixed
1058                broken $test_broken
1059                failed $test_failure
1060
1061                EOF
1062        fi
1063
1064        if test "$test_fixed" != 0
1065        then
1066                say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
1067        fi
1068        if test "$test_broken" != 0
1069        then
1070                say_color warn "# still have $test_broken known breakage(s)"
1071        fi
1072        if test "$test_broken" != 0 || test "$test_fixed" != 0
1073        then
1074                test_remaining=$(( $test_count - $test_broken - $test_fixed ))
1075                msg="remaining $test_remaining test(s)"
1076        else
1077                test_remaining=$test_count
1078                msg="$test_count test(s)"
1079        fi
1080        case "$test_failure" in
1081        0)
1082                if test $test_external_has_tap -eq 0
1083                then
1084                        if test $test_remaining -gt 0
1085                        then
1086                                say_color pass "# passed all $msg"
1087                        fi
1088
1089                        # Maybe print SKIP message
1090                        test -z "$skip_all" || skip_all="# SKIP $skip_all"
1091                        case "$test_count" in
1092                        0)
1093                                say "1..$test_count${skip_all:+ $skip_all}"
1094                                ;;
1095                        *)
1096                                test -z "$skip_all" ||
1097                                say_color warn "$skip_all"
1098                                say "1..$test_count"
1099                                ;;
1100                        esac
1101                fi
1102
1103                if test -z "$debug"
1104                then
1105                        test -d "$TRASH_DIRECTORY" ||
1106                        error "Tests passed but trash directory already removed before test cleanup; aborting"
1107
1108                        cd "$TRASH_DIRECTORY/.." &&
1109                        rm -fr "$TRASH_DIRECTORY" || {
1110                                # try again in a bit
1111                                sleep 5;
1112                                rm -fr "$TRASH_DIRECTORY"
1113                        } ||
1114                        error "Tests passed but test cleanup failed; aborting"
1115                fi
1116                test_at_end_hook_
1117
1118                exit 0 ;;
1119
1120        *)
1121                if test $test_external_has_tap -eq 0
1122                then
1123                        say_color error "# failed $test_failure among $msg"
1124                        say "1..$test_count"
1125                fi
1126
1127                exit 1 ;;
1128
1129        esac
1130}
1131
1132if test -n "$valgrind"
1133then
1134        make_symlink () {
1135                test -h "$2" &&
1136                test "$1" = "$(readlink "$2")" || {
1137                        # be super paranoid
1138                        if mkdir "$2".lock
1139                        then
1140                                rm -f "$2" &&
1141                                ln -s "$1" "$2" &&
1142                                rm -r "$2".lock
1143                        else
1144                                while test -d "$2".lock
1145                                do
1146                                        say "Waiting for lock on $2."
1147                                        sleep 1
1148                                done
1149                        fi
1150                }
1151        }
1152
1153        make_valgrind_symlink () {
1154                # handle only executables, unless they are shell libraries that
1155                # need to be in the exec-path.
1156                test -x "$1" ||
1157                test "# " = "$(test_copy_bytes 2 <"$1")" ||
1158                return;
1159
1160                base=$(basename "$1")
1161                case "$base" in
1162                test-*)
1163                        symlink_target="$GIT_BUILD_DIR/t/helper/$base"
1164                        ;;
1165                *)
1166                        symlink_target="$GIT_BUILD_DIR/$base"
1167                        ;;
1168                esac
1169                # do not override scripts
1170                if test -x "$symlink_target" &&
1171                    test ! -d "$symlink_target" &&
1172                    test "#!" != "$(test_copy_bytes 2 <"$symlink_target")"
1173                then
1174                        symlink_target=../valgrind.sh
1175                fi
1176                case "$base" in
1177                *.sh|*.perl)
1178                        symlink_target=../unprocessed-script
1179                esac
1180                # create the link, or replace it if it is out of date
1181                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
1182        }
1183
1184        # override all git executables in TEST_DIRECTORY/..
1185        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
1186        mkdir -p "$GIT_VALGRIND"/bin
1187        for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
1188        do
1189                make_valgrind_symlink $file
1190        done
1191        # special-case the mergetools loadables
1192        make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
1193        OLDIFS=$IFS
1194        IFS=:
1195        for path in $PATH
1196        do
1197                ls "$path"/git-* 2> /dev/null |
1198                while read file
1199                do
1200                        make_valgrind_symlink "$file"
1201                done
1202        done
1203        IFS=$OLDIFS
1204        PATH=$GIT_VALGRIND/bin:$PATH
1205        GIT_EXEC_PATH=$GIT_VALGRIND/bin
1206        export GIT_VALGRIND
1207        GIT_VALGRIND_MODE="$valgrind"
1208        export GIT_VALGRIND_MODE
1209        GIT_VALGRIND_ENABLED=t
1210        test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
1211        export GIT_VALGRIND_ENABLED
1212elif test -n "$GIT_TEST_INSTALLED"
1213then
1214        GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
1215        error "Cannot run git from $GIT_TEST_INSTALLED."
1216        PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR/t/helper:$PATH
1217        GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
1218else # normal case, use ../bin-wrappers only unless $with_dashes:
1219        if test -n "$no_bin_wrappers"
1220        then
1221                with_dashes=t
1222        else
1223                git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1224                if ! test -x "$git_bin_dir/git"
1225                then
1226                        if test -z "$with_dashes"
1227                        then
1228                                say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
1229                        fi
1230                        with_dashes=t
1231                fi
1232                PATH="$git_bin_dir:$PATH"
1233        fi
1234        GIT_EXEC_PATH=$GIT_BUILD_DIR
1235        if test -n "$with_dashes"
1236        then
1237                PATH="$GIT_BUILD_DIR:$GIT_BUILD_DIR/t/helper:$PATH"
1238        fi
1239fi
1240GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
1241GIT_CONFIG_NOSYSTEM=1
1242GIT_ATTR_NOSYSTEM=1
1243export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
1244
1245if test -z "$GIT_TEST_CMP"
1246then
1247        if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1248        then
1249                GIT_TEST_CMP="$DIFF -c"
1250        else
1251                GIT_TEST_CMP="$DIFF -u"
1252        fi
1253fi
1254
1255GITPERLLIB="$GIT_BUILD_DIR"/perl/build/lib
1256export GITPERLLIB
1257test -d "$GIT_BUILD_DIR"/templates/blt || {
1258        error "You haven't built things yet, have you?"
1259}
1260
1261if ! test -x "$GIT_BUILD_DIR"/t/helper/test-tool$X
1262then
1263        echo >&2 'You need to build test-tool:'
1264        echo >&2 'Run "make t/helper/test-tool" in the source (toplevel) directory'
1265        exit 1
1266fi
1267
1268# Test repository
1269rm -fr "$TRASH_DIRECTORY" || {
1270        GIT_EXIT_OK=t
1271        echo >&5 "FATAL: Cannot prepare test area"
1272        exit 1
1273}
1274
1275HOME="$TRASH_DIRECTORY"
1276GNUPGHOME="$HOME/gnupg-home-not-used"
1277export HOME GNUPGHOME
1278
1279if test -z "$TEST_NO_CREATE_REPO"
1280then
1281        test_create_repo "$TRASH_DIRECTORY"
1282else
1283        mkdir -p "$TRASH_DIRECTORY"
1284fi
1285
1286# Use -P to resolve symlinks in our working directory so that the cwd
1287# in subprocesses like git equals our $PWD (for pathname comparisons).
1288cd -P "$TRASH_DIRECTORY" || exit 1
1289
1290this_test=${0##*/}
1291this_test=${this_test%%-*}
1292if match_pattern_list "$this_test" $GIT_SKIP_TESTS
1293then
1294        say_color info >&3 "skipping test $this_test altogether"
1295        skip_all="skip all tests in $this_test"
1296        test_done
1297fi
1298
1299if test -n "$write_junit_xml"
1300then
1301        junit_xml_dir="$TEST_OUTPUT_DIRECTORY/out"
1302        mkdir -p "$junit_xml_dir"
1303        junit_xml_base=${0##*/}
1304        junit_xml_path="$junit_xml_dir/TEST-${junit_xml_base%.sh}.xml"
1305        junit_attrs="name=\"${junit_xml_base%.sh}\""
1306        junit_attrs="$junit_attrs timestamp=\"$(TZ=UTC \
1307                date +%Y-%m-%dT%H:%M:%S)\""
1308        write_junit_xml --truncate "<testsuites>" "  <testsuite $junit_attrs>"
1309        junit_suite_start=$(test-tool date getnanos)
1310        if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
1311        then
1312                GIT_TEST_TEE_OFFSET=0
1313        fi
1314fi
1315
1316# Provide an implementation of the 'yes' utility
1317yes () {
1318        if test $# = 0
1319        then
1320                y=y
1321        else
1322                y="$*"
1323        fi
1324
1325        i=0
1326        while test $i -lt 99
1327        do
1328                echo "$y"
1329                i=$(($i+1))
1330        done
1331}
1332
1333# Fix some commands on Windows
1334uname_s=$(uname -s)
1335case $uname_s in
1336*MINGW*)
1337        # Windows has its own (incompatible) sort and find
1338        sort () {
1339                /usr/bin/sort "$@"
1340        }
1341        find () {
1342                /usr/bin/find "$@"
1343        }
1344        # git sees Windows-style pwd
1345        pwd () {
1346                builtin pwd -W
1347        }
1348        # no POSIX permissions
1349        # backslashes in pathspec are converted to '/'
1350        # exec does not inherit the PID
1351        test_set_prereq MINGW
1352        test_set_prereq NATIVE_CRLF
1353        test_set_prereq SED_STRIPS_CR
1354        test_set_prereq GREP_STRIPS_CR
1355        GIT_TEST_CMP=mingw_test_cmp
1356        ;;
1357*CYGWIN*)
1358        test_set_prereq POSIXPERM
1359        test_set_prereq EXECKEEPSPID
1360        test_set_prereq CYGWIN
1361        test_set_prereq SED_STRIPS_CR
1362        test_set_prereq GREP_STRIPS_CR
1363        ;;
1364*)
1365        test_set_prereq POSIXPERM
1366        test_set_prereq BSLASHPSPEC
1367        test_set_prereq EXECKEEPSPID
1368        ;;
1369esac
1370
1371( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1372test -z "$NO_PERL" && test_set_prereq PERL
1373test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
1374test -z "$NO_PYTHON" && test_set_prereq PYTHON
1375test -n "$USE_LIBPCRE1$USE_LIBPCRE2" && test_set_prereq PCRE
1376test -n "$USE_LIBPCRE1" && test_set_prereq LIBPCRE1
1377test -n "$USE_LIBPCRE2" && test_set_prereq LIBPCRE2
1378test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1379
1380if test -n "$GIT_TEST_GETTEXT_POISON_ORIG"
1381then
1382        GIT_TEST_GETTEXT_POISON=$GIT_TEST_GETTEXT_POISON_ORIG
1383        unset GIT_TEST_GETTEXT_POISON_ORIG
1384fi
1385
1386# Can we rely on git's output in the C locale?
1387if test -z "$GIT_TEST_GETTEXT_POISON"
1388then
1389        test_set_prereq C_LOCALE_OUTPUT
1390fi
1391
1392if test -z "$GIT_TEST_CHECK_CACHE_TREE"
1393then
1394        GIT_TEST_CHECK_CACHE_TREE=true
1395        export GIT_TEST_CHECK_CACHE_TREE
1396fi
1397
1398test_lazy_prereq PIPE '
1399        # test whether the filesystem supports FIFOs
1400        test_have_prereq !MINGW,!CYGWIN &&
1401        rm -f testfifo && mkfifo testfifo
1402'
1403
1404test_lazy_prereq SYMLINKS '
1405        # test whether the filesystem supports symbolic links
1406        ln -s x y && test -h y
1407'
1408
1409test_lazy_prereq FILEMODE '
1410        test "$(git config --bool core.filemode)" = true
1411'
1412
1413test_lazy_prereq CASE_INSENSITIVE_FS '
1414        echo good >CamelCase &&
1415        echo bad >camelcase &&
1416        test "$(cat CamelCase)" != good
1417'
1418
1419test_lazy_prereq FUNNYNAMES '
1420        test_have_prereq !MINGW &&
1421        touch -- \
1422                "FUNNYNAMES tab embedded" \
1423                "FUNNYNAMES \"quote embedded\"" \
1424                "FUNNYNAMES newline
1425embedded" 2>/dev/null &&
1426        rm -- \
1427                "FUNNYNAMES tab embedded" \
1428                "FUNNYNAMES \"quote embedded\"" \
1429                "FUNNYNAMES newline
1430embedded" 2>/dev/null
1431'
1432
1433test_lazy_prereq UTF8_NFD_TO_NFC '
1434        # check whether FS converts nfd unicode to nfc
1435        auml=$(printf "\303\244")
1436        aumlcdiar=$(printf "\141\314\210")
1437        >"$auml" &&
1438        test -f "$aumlcdiar"
1439'
1440
1441test_lazy_prereq AUTOIDENT '
1442        sane_unset GIT_AUTHOR_NAME &&
1443        sane_unset GIT_AUTHOR_EMAIL &&
1444        git var GIT_AUTHOR_IDENT
1445'
1446
1447test_lazy_prereq EXPENSIVE '
1448        test -n "$GIT_TEST_LONG"
1449'
1450
1451test_lazy_prereq EXPENSIVE_ON_WINDOWS '
1452        test_have_prereq EXPENSIVE || test_have_prereq !MINGW,!CYGWIN
1453'
1454
1455test_lazy_prereq USR_BIN_TIME '
1456        test -x /usr/bin/time
1457'
1458
1459test_lazy_prereq NOT_ROOT '
1460        uid=$(id -u) &&
1461        test "$uid" != 0
1462'
1463
1464test_lazy_prereq JGIT '
1465        type jgit
1466'
1467
1468# SANITY is about "can you correctly predict what the filesystem would
1469# do by only looking at the permission bits of the files and
1470# directories?"  A typical example of !SANITY is running the test
1471# suite as root, where a test may expect "chmod -r file && cat file"
1472# to fail because file is supposed to be unreadable after a successful
1473# chmod.  In an environment (i.e. combination of what filesystem is
1474# being used and who is running the tests) that lacks SANITY, you may
1475# be able to delete or create a file when the containing directory
1476# doesn't have write permissions, or access a file even if the
1477# containing directory doesn't have read or execute permissions.
1478
1479test_lazy_prereq SANITY '
1480        mkdir SANETESTD.1 SANETESTD.2 &&
1481
1482        chmod +w SANETESTD.1 SANETESTD.2 &&
1483        >SANETESTD.1/x 2>SANETESTD.2/x &&
1484        chmod -w SANETESTD.1 &&
1485        chmod -r SANETESTD.1/x &&
1486        chmod -rx SANETESTD.2 ||
1487        BUG "cannot prepare SANETESTD"
1488
1489        ! test -r SANETESTD.1/x &&
1490        ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1491        status=$?
1492
1493        chmod +rwx SANETESTD.1 SANETESTD.2 &&
1494        rm -rf SANETESTD.1 SANETESTD.2 ||
1495        BUG "cannot clean SANETESTD"
1496        return $status
1497'
1498
1499test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
1500GIT_UNZIP=${GIT_UNZIP:-unzip}
1501test_lazy_prereq UNZIP '
1502        "$GIT_UNZIP" -v
1503        test $? -ne 127
1504'
1505
1506run_with_limited_cmdline () {
1507        (ulimit -s 128 && "$@")
1508}
1509
1510test_lazy_prereq CMDLINE_LIMIT '
1511        test_have_prereq !MINGW,!CYGWIN &&
1512        run_with_limited_cmdline true
1513'
1514
1515run_with_limited_stack () {
1516        (ulimit -s 128 && "$@")
1517}
1518
1519test_lazy_prereq ULIMIT_STACK_SIZE '
1520        test_have_prereq !MINGW,!CYGWIN &&
1521        run_with_limited_stack true
1522'
1523
1524build_option () {
1525        git version --build-options |
1526        sed -ne "s/^$1: //p"
1527}
1528
1529test_lazy_prereq LONG_IS_64BIT '
1530        test 8 -le "$(build_option sizeof-long)"
1531'
1532
1533test_lazy_prereq TIME_IS_64BIT 'test-tool date is64bit'
1534test_lazy_prereq TIME_T_IS_64BIT 'test-tool date time_t-is64bit'
1535
1536test_lazy_prereq CURL '
1537        curl --version
1538'
1539
1540# SHA1 is a test if the hash algorithm in use is SHA-1.  This is both for tests
1541# which will not work with other hash algorithms and tests that work but don't
1542# test anything meaningful (e.g. special values which cause short collisions).
1543test_lazy_prereq SHA1 '
1544        test $(git hash-object /dev/null) = e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
1545'
1546
1547test_lazy_prereq REBASE_P '
1548        test -z "$GIT_TEST_SKIP_REBASE_P"
1549'